Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerFilterPanel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerFilterPanel.cpp	(revision 70675)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerFilterPanel.cpp	(revision 70676)
@@ -358,5 +358,5 @@
     prepareRadioButtonGroup();
 
-    m_pFilterComboBox = new QComboBox(this);
+    m_pFilterComboBox = new QComboBox;
     if (m_pFilterComboBox)
     {
@@ -370,5 +370,5 @@
     }
 
-    m_pAddFilterTermButton = new QIToolButton(this);
+    m_pAddFilterTermButton = new QIToolButton;
     if (m_pAddFilterTermButton)
     {
@@ -377,5 +377,5 @@
     }
 
-    m_pFilterTermsLineEdit = new UIVMFilterLineEdit(this);
+    m_pFilterTermsLineEdit = new UIVMFilterLineEdit;
     if (m_pFilterTermsLineEdit)
     {
@@ -384,5 +384,5 @@
     }
 
-    m_pResultLabel = new QLabel(this);
+    m_pResultLabel = new QLabel;
     if (m_pResultLabel)
     {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerPanel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerPanel.cpp	(revision 70675)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerPanel.cpp	(revision 70676)
@@ -79,5 +79,5 @@
         m_pMainLayout->setSpacing(2);
     }
-    m_pCloseButton = new UIMiniCancelButton(this);
+    m_pCloseButton = new UIMiniCancelButton;
     if (m_pCloseButton)
     {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerSearchPanel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerSearchPanel.cpp	(revision 70675)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerSearchPanel.cpp	(revision 70676)
@@ -184,5 +184,5 @@
 
     /* Create search-editor: */
-    m_pSearchEditor = new UISearchField(this);
+    m_pSearchEditor = new UISearchField(0 /* parent */);
     if (m_pSearchEditor)
     {
@@ -194,5 +194,5 @@
 
     /* Create search-label: */
-    m_pSearchLabel = new QLabel(this);
+    m_pSearchLabel = new QLabel;
     if (m_pSearchLabel)
     {
@@ -210,5 +210,5 @@
 
     /* Create Next/Prev button-box: */
-    m_pNextPrevButtons = new UIRoundRectSegmentedButton(this, 2);
+    m_pNextPrevButtons = new UIRoundRectSegmentedButton(0 /* parent */, 2);
     if (m_pNextPrevButtons)
     {
@@ -239,5 +239,5 @@
     }
 
-    m_pMatchWholeWordCheckBox = new QCheckBox(this);
+    m_pMatchWholeWordCheckBox = new QCheckBox;
     if (m_pMatchWholeWordCheckBox)
     {
@@ -253,5 +253,5 @@
     }
 
-    m_pHighlightAllCheckBox = new QCheckBox(this);
+    m_pHighlightAllCheckBox = new QCheckBox;
     if (m_pHighlightAllCheckBox)
     {
@@ -267,5 +267,5 @@
 
     /* Create warning-icon: */
-    m_pWarningIcon = new QLabel(this);
+    m_pWarningIcon = new QLabel;
     if (m_pWarningIcon)
     {
@@ -280,5 +280,5 @@
 
     /* Create warning-label: */
-    m_pInfoLabel = new QLabel(this);
+    m_pInfoLabel = new QLabel;
     if (m_pInfoLabel)
     {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp	(revision 70675)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp	(revision 70676)
@@ -71,4 +71,5 @@
     , m_pActionSave(0)
     , m_pActionBookmark(0)
+    , m_pActionSettings(0)
     , m_pMenu(0)
     , m_bShowLineNumbers(true)
@@ -169,4 +170,6 @@
 void UIVMLogViewerWidget::sltRefresh()
 {
+    if (!m_pTabWidget)
+        return;
     /* Disconnect this connection to avoid initial signals during page creation/deletion: */
     disconnect(m_pTabWidget, &QITabWidget::currentChanged, m_pFilterPanel, &UIVMLogViewerFilterPanel::applyFilter);
@@ -196,14 +199,20 @@
 
     /* Setup this connection after refresh to avoid initial signals during page creation: */
-    connect(m_pTabWidget, &QITabWidget::currentChanged, m_pFilterPanel, &UIVMLogViewerFilterPanel::applyFilter);
+    if (m_pFilterPanel)
+        connect(m_pTabWidget, &QITabWidget::currentChanged, m_pFilterPanel, &UIVMLogViewerFilterPanel::applyFilter);
     connect(m_pTabWidget, &QITabWidget::currentChanged, this, &UIVMLogViewerWidget::sltTabIndexChange);
 
     /* Enable/Disable toolbar actions (except Refresh) & tab widget according log presence: */
-    m_pActionFind->setEnabled(!noLogsToShow);
-    m_pActionFilter->setEnabled(!noLogsToShow);
-    m_pActionSave->setEnabled(!noLogsToShow);
-    m_pActionBookmark->setEnabled(!noLogsToShow);
+    if (m_pActionFind)
+        m_pActionFind->setEnabled(!noLogsToShow);
+    if (m_pActionFilter)
+        m_pActionFilter->setEnabled(!noLogsToShow);
+    if (m_pActionSave)
+        m_pActionSave->setEnabled(!noLogsToShow);
+    if (m_pActionBookmark)
+        m_pActionBookmark->setEnabled(!noLogsToShow);
     //m_pTabWidget->setEnabled(!noLogsToShow);
-    m_pActionSettings->setEnabled(!noLogsToShow);
+    if (m_pActionSettings)
+        m_pActionSettings->setEnabled(!noLogsToShow);
     m_pTabWidget->show();
     if (m_pSearchPanel && m_pSearchPanel->isVisible())
@@ -352,13 +361,10 @@
     m_pMainLayout = new QVBoxLayout(this);
 
-    /* Prepare widgets: */
+    prepareToolBar();
+    prepareActions();
+    
+    prepareMenu();
     prepareWidgets();
-
-
-    prepareActions();
-
-    prepareToolBar();
-    prepareMenu();
-
+    
     /* Reading log files: */
     sltRefresh();
@@ -384,13 +390,13 @@
 
     /* Create VM Log-Viewer container: */
-    m_pTabWidget = new QITabWidget(this);
+    m_pTabWidget = new QITabWidget;
     if (m_pTabWidget)
     {
         /* Add VM Log-Viewer container to main-layout: */
-        m_pMainLayout->insertWidget(1, m_pTabWidget);
+        m_pMainLayout->addWidget(m_pTabWidget);
     }
 
     /* Create VM Log-Viewer search-panel: */
-    m_pSearchPanel = new UIVMLogViewerSearchPanel(this, this);
+    m_pSearchPanel = new UIVMLogViewerSearchPanel(0, this);
     if (m_pSearchPanel)
     {
@@ -399,5 +405,5 @@
         m_pSearchPanel->hide();
         /* Add VM Log-Viewer search-panel to main-layout: */
-        m_pMainLayout->insertWidget(2, m_pSearchPanel);
+        m_pMainLayout->addWidget(m_pSearchPanel);
         connect(m_pSearchPanel, &UIVMLogViewerSearchPanel::sigHighlightingUpdated,
                 this, &UIVMLogViewerWidget::sltSearchResultHighLigting);
@@ -405,5 +411,5 @@
 
     /* Create VM Log-Viewer filter-panel: */
-    m_pFilterPanel = new UIVMLogViewerFilterPanel(this, this);
+    m_pFilterPanel = new UIVMLogViewerFilterPanel(0, this);
     if (m_pFilterPanel)
     {
@@ -412,15 +418,15 @@
         m_pFilterPanel->hide();
         /* Add VM Log-Viewer filter-panel to main-layout: */
-        m_pMainLayout->insertWidget(3, m_pFilterPanel);
+        m_pMainLayout->addWidget(m_pFilterPanel);
         connect(m_pFilterPanel, &UIVMLogViewerFilterPanel::sigFilterApplied,
                 this, &UIVMLogViewerWidget::sltFilterApplied);
     }
 
-    m_pBookmarksPanel = new UIVMLogViewerBookmarksPanel(this, this);
+    m_pBookmarksPanel = new UIVMLogViewerBookmarksPanel(0, this);
     if (m_pBookmarksPanel)
     {
         installEventFilter(m_pBookmarksPanel);
         m_pBookmarksPanel->hide();
-        m_pMainLayout->insertWidget(4, m_pBookmarksPanel);
+        m_pMainLayout->addWidget(m_pBookmarksPanel);
         connect(m_pBookmarksPanel, &UIVMLogViewerBookmarksPanel::sigDeleteBookmark,
                 this, &UIVMLogViewerWidget::sltDeleteBookmark);
@@ -431,5 +437,5 @@
     }
 
-    m_pSettingsPanel = new UIVMLogViewerSettingsPanel(this, this);
+    m_pSettingsPanel = new UIVMLogViewerSettingsPanel(0, this);
     if (m_pSettingsPanel)
     {
@@ -441,5 +447,5 @@
         m_pSettingsPanel->setFontSizeInPoints(m_iFontSizeInPoints);
 
-        m_pMainLayout->insertWidget(5, m_pSettingsPanel);
+        m_pMainLayout->addWidget(m_pSettingsPanel);
         connect(m_pSettingsPanel, &UIVMLogViewerSettingsPanel::sigShowLineNumbers, this, &UIVMLogViewerWidget::sltShowLineNumbers);
         connect(m_pSettingsPanel, &UIVMLogViewerSettingsPanel::sigWrapLines, this, &UIVMLogViewerWidget::sltWrapLines);
@@ -580,5 +586,5 @@
 #else
         /* Add into layout: */
-        m_pMainLayout->insertWidget(0, m_pToolBar);
+        m_pMainLayout->addWidget(m_pToolBar);
 #endif
     }
@@ -838,5 +844,5 @@
 
     /* Create page-container: */
-    UIVMLogPage* pLogPage = new UIVMLogPage(this);
+    UIVMLogPage* pLogPage = new UIVMLogPage();
     if (pLogPage)
     {